<!doctype html>
<!--
    Copyright (c) 2010, 2025 Contributors to the Eclipse Foundation

    See the NOTICE file(s) distributed with this work for additional
    information regarding copyright ownership.

    This program and the accompanying materials are made available under the terms
    of the MIT License which is available at https://opensource.org/licenses/MIT

    SPDX-License-Identifier: MIT
-->
<html lang="en">
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <title>Module 5.2 | SBE Course</title>
        <link rel="icon" type="image/png" href="../sbe-course-favicon.png"/>

        <!-- Bootstrap. -->
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/css/bootstrap.min.css" crossorigin="anonymous">
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.6.0/font/bootstrap-icons.css" crossorigin="anonymous">
        <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/js/bootstrap.bundle.min.js" crossorigin="anonymous"></script>

        <!-- Website styling. -->
        <link rel="stylesheet" href="../../assets/eclipse-escet.css">
        <link rel="stylesheet" href="../../assets/eclipse-escet-sbe-course.css">

        <!-- Version selector. -->
        <script src="../../assets/eclipse-escet.js"></script>

        <!-- Code block syntax highlighting. -->
        <link rel="stylesheet" href="../../assets/styles/asciidoctor-highlightjs-escet.min.css">
        <script src="../../assets/highlight.min.js"></script>
        <script src="../../assets/languages/cif.min.js"></script>
        <script src="../../assets/languages/tooldef.min.js"></script>

        <!-- Quiz. -->
        <link rel="stylesheet" href="../assets/quiz.css">
        <script src="../assets/quiz.js"></script>

        <!-- SBE course. -->
        <link rel="stylesheet" href="../assets/course.css">
        <script src="../assets/course.js"></script>
    </head>

    <body class="escet-dark">

        <!-- Top navigation bar -->
        <nav class="navbar navbar-expand-lg navbar-dark escet-bg">
            <div class="container-fluid">
                <a class="navbar-brand d-lg-none">SBE Course</a>
                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <ul class="navbar-nav me-auto mb-0 mb-lg-0">
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle escet-brand px-0" href="#" id="navbarDropdown" role="button" data-bs-toggle="dropdown" aria-expanded="false">Eclipse ESCET™ / SBE Course</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown">
                                <li><a class="dropdown-item" href="../.."><img src="../../eclipse-escet-favicon.png" class="pe-2"> Eclipse ESCET / Project</a></li>
                                <li><a class="dropdown-item" href=".."><img src="../sbe-course-favicon.png" class="pe-2"> Eclipse ESCET / SBE Course</a></li>
                                <li><a class="dropdown-item" href="../../cif"><img src="../../cif/cif-favicon.png" class="pe-2"> Eclipse ESCET / CIF</a></li>
                                <li><a class="dropdown-item" href="../../chi"><img src="../../chi/chi-favicon.png" class="pe-2"> Eclipse ESCET / Chi</a></li>
                                <li><a class="dropdown-item" href="../../tooldef"><img src="../../tooldef/tooldef-favicon.png" class="pe-2"> Eclipse ESCET / ToolDef</a></li>
                            </ul>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link" href="../" aria-expanded="false">Home</a>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown1" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 1</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown1">
                                <li><a class="dropdown-item" href="../module1">Module 1: Supervisory control of discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/supervisory-control.html">Module 1.1: Supervisory control</a></li>
                                <li><a class="dropdown-item" href="../module1/discrete-event-systems.html">Module 1.2: Discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/modeling-discrete-event-systems.html">Module 1.3: Modeling discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/get-started-with-cif.html">Module 1.4: Get started with CIF</a></li>
                                <li><a class="dropdown-item" href="../module1/exercises.html">Module 1.5: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module1/introduction-to-the-water-lock-case.html">Module 1.6: Introduction to the water lock case</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown2" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 2</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown2">
                                <li><a class="dropdown-item" href="../module2">Module 2: Working with automata</a></li>
                                <li><a class="dropdown-item" href="../module2/reachability-deadlock-blocking-livelock.html">Module 2.1: Reachability, deadlock, blocking and livelock</a></li>
                                <li><a class="dropdown-item" href="../module2/non-deterministic-automata.html">Module 2.2: Non-deterministic automata</a></li>
                                <li><a class="dropdown-item" href="../module2/synchronizing-automata.html">Module 2.3: Synchronizing automata</a></li>
                                <li><a class="dropdown-item" href="../module2/shared-variables.html">Module 2.4: Shared variables</a></li>
                                <li><a class="dropdown-item" href="../module2/computing-state-spaces.html">Module 2.5: Computing state spaces</a></li>
                                <li><a class="dropdown-item" href="../module2/cif-tools-view-analyze-models.html">Module 2.6: CIF tools to view and analyze models</a></li>
                                <li><a class="dropdown-item" href="../module2/constants-and-algebraic-variables.html">Module 2.7: Constants and algebraic variables</a></li>
                                <li><a class="dropdown-item" href="../module2/exercises.html">Module 2.8: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module2/more-detailed-models-water-lock-case.html">Module 2.9: More detailed models for the water lock case</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown3" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 3</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown3">
                                <li><a class="dropdown-item" href="../module3">Module 3: Supervisory control and plant models</a></li>
                                <li><a class="dropdown-item" href="../module3/supervisory-control-loop.html">Module 3.1: Supervisory control loop</a></li>
                                <li><a class="dropdown-item" href="../module3/synthesis-guarantees.html">Module 3.2: Synthesis guarantees</a></li>
                                <li><a class="dropdown-item" href="../module3/supervisory-controller-synthesis.html">Module 3.3: Supervisory controller synthesis</a></li>
                                <li><a class="dropdown-item" href="../module3/modeling-larger-systems.html">Module 3.4: Modeling larger systems</a></li>
                                <li><a class="dropdown-item" href="../module3/exercises.html">Module 3.5: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module3/water-lock-case-plant-models.html">Module 3.6: Water lock case plant models</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown4" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 4</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown4">
                                <li><a class="dropdown-item" href="../module4">Module 4: Modeling requirements and supervisor synthesis</a></li>
                                <li><a class="dropdown-item" href="../module4/user-specified-requirements.html">Module 4.1: User-specified requirements</a></li>
                                <li><a class="dropdown-item" href="../module4/requirement-automata-and-invariants.html">Module 4.2: Requirements automata and invariants</a></li>
                                <li><a class="dropdown-item" href="../module4/synthesis-with-requirements.html">Module 4.3: Synthesis with requirements</a></li>
                                <li><a class="dropdown-item" href="../module4/modeling-for-synthesis.html">Module 4.4: Modeling for synthesis</a></li>
                                <li><a class="dropdown-item" href="../module4/performing-synthesis-with-cif.html">Module 4.5: Performing synthesis with CIF</a></li>
                                <li><a class="dropdown-item" href="../module4/introduction-to-svg-visualization.html">Module 4.6: Introduction to SVG visualization</a></li>
                                <li><a class="dropdown-item" href="../module4/exercises.html">Module 4.7: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module4/water-lock-case-requirements-and-supervisor.html">Module 4.8: Water lock case requirements and supervisor</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle active" aria-current="page" href="#" id="navbarDropdown5" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 5</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown5">
                                <li><a class="dropdown-item" href="./">Module 5: Hybrid simulation models</a></li>
                                <li><a class="dropdown-item" href="timed-and-hybrid-models.html">Module 5.1: Timed and hybrid models</a></li>
                                <li><a class="dropdown-item active" aria-current="page" href="variable-time.html">Module 5.2: Variable 'time'</a></li>
                                <li><a class="dropdown-item" href="continuous-variables.html">Module 5.3: Continuous variables</a></li>
                                <li><a class="dropdown-item" href="urgency.html">Module 5.4: Urgency</a></li>
                                <li><a class="dropdown-item" href="tau-event.html">Module 5.5: The 'tau' event</a></li>
                                <li><a class="dropdown-item" href="exercises.html">Module 5.6: Exercises</a></li>
                                <li><a class="dropdown-item" href="water-lock-case-hybrid-model.html">Module 5.7: Water lock case hybrid model</a></li>
                                <li><a class="dropdown-item" href="course-conclusion.html">Module 5.8: Course conclusion</a></li>
                            </ul>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>

        <!-- Intro -->
        <div id="intro" class="position-relative p-3 text-center escet-bg escet-bg-opacity-125">
            <div class="clearfix mb-4 mb-md-0">
                <span class="float-end">
                    Version:
                    <div class="dropdown d-inline-block">
                        <a class="dropdown-toggle" href="#" role="button" id="versionDropdown" data-bs-toggle="dropdown" aria-expanded="false">@@ESCET-VERSION-ENDUSER@@</a>
                        <ul id="versions-dropdown" class="dropdown-menu dropdown-menu-end" aria-labelledby="versionDropdown" data-this-version="/@@ESCET-DEPLOY-FOLDER-NAME@@">
                            <li><h6 id="versions-previews" class="dropdown-header">Previews</h6></li>
                            <li><h6 id="versions-latest-releases" class="dropdown-header">Latest releases</h6></li>
                            <li><h6 class="dropdown-header">Other</h6></li>
                            <li><a class="dropdown-item" href="../../versions.html">All versions...</a></li>
                        </ul>
                    </div>
                    <a class="text-nowrap ms-3" href="../../release-notes.html">[release notes]</a>
                </span>
            </div>
        </div>

        <!-- Content -->
        <div class="px-4 pt-5">
            <div class="row justify-content-center">
                <div class="col-12 col-md-10 col-xl-8 col-xxl-6" id="content">

                    <h1>Module 5.2: Variable 'time'</h1>
                    <p>
                        In CIF, the variable <code>time</code> is always present; you don't have to declare it.
                        In this variable, the time that has passed is tracked.
                        So, it for instance indicates the time since a simulation of the model started.
                    </p>
                    <p>
                        Officially, the unit of time is not defined by the CIF language.
                        However, CIF tools interpret time by default as being represented in seconds.
                        Some tools allow it to be configured, essentially making time run faster or slower.
                    </p>
                    <p>
                        Variable <code>time</code> is of type <code>real</code>.
                        While type <code>int</code> only allows whole numbers, type <code>real</code> also allows for instance values <code>0.0004</code>, <code>1.5</code> and <code>3015.4673519</code>.
                        Variable <code>time</code> initially has value <code>0.0</code>, and it gradually increases as time goes on.
                        For instance, one simulated second later it is <code>1.0</code>, yet again a simulated second later it is <code>2.0</code>, and another simulated half a second later it is <code>2.5</code>.
                        Keep in mind that simulated time may run faster or slower than wall-clock time.
                    </p>
                    <p>
                        The value of variable <code>time</code> can be used in the model like that of any other variable.
                        It can thus for instance be used in guards.
                        However, variable <code>time</code> is read-only.
                        You thus can't assign it new values, similar to how algebraic variables can't be assigned a value.
                    </p>

                    <h2 id="stopwatch-example">Example</h2>
                    <p>
                        As an example of using variable <code>time</code>, consider the following CIF model:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            automaton Stopwatch:
                                event time_passed;

                                location Zero:
                                    initial;
                                    marked;
                                    edge time_passed when time &gt;= 60  goto One;

                                location One:
                                    edge time_passed when time &gt;= 120 goto Two;

                                location Two:
                                    edge time_passed when time &gt;= 180 goto Three;

                                location Three;
                            end
                        </code>
                    </pre>
                    <p>
                        The <code>Stopwatch</code> automaton models a stopwatch.
                        It counts the number of full minutes of time that have passed, up to three minutes.
                        Initially, <code>Zero</code> full minutes have passed.
                        Once variable <code>time</code> reaches <code>60</code>, the first minute has passed, and the automaton goes to its <code>One</code> location.
                        That is, the automaton stays in the <code>Zero</code> location for the first minute, and only when the guard holds does it transition to the <code>One</code> location.
                        Then, once <code>120</code> seconds have passed, it goes to its <code>Two</code> location, and similarly it goes to its <code>Three</code> location once <code>180</code> seconds have passed.
                        The automaton only tracks passage of up to three minutes, and thus in location <code>Three</code> it stops tracking time.
                        Note the <code>;</code> after <code>Three</code>, which indicates that this location has no elements, such as <code>initial</code>, <code>marked</code> or edges.
                        Time will still pass, and thus variable <code>time</code> still increases in value, but event <code>time_passes</code> is not enabled, and thus no more transitions can occur for it.
                        Time may then progress indefinitely, while the automaton stays in its <code>Three</code> location.
                    </p>
                    <p>
                        By using <code>time</code> in the guards, the behavior of the model becomes time-dependent.
                        For instance, the occurrence of transitions for the <code>time_passed</code> event in the example above depend on the passage of time.
                    </p>
                    <p>
                        You may have noticed that we used guard <code>time &gt;= 60</code>.
                        You could have expected <code>time = 60</code>, since the event should be enabled after 60 seconds, and not after 60.1 or 63 seconds.
                        And theoretically, you'd be correct.
                        However, practically, variable <code>time</code> has value <code>60</code> only for an infinitely small duration.
                        When for instance a simulator measures time, it will likely not evaluate the guard exactly when <code>time</code> is 60.
                        If it regularly checks whether the guard has becomes enabled, it could also determine that the guard holds just after a minute has passed, for instance when variable <code>time</code> is <code>60.0000000000001</code> or so.
                        Guard <code>time &gt;= 60</code> thus indicates that the event becomes enabled after a minute has passed.
                        The simulator will try to enable the event as soon as possible after a minute of time has passed.
                        Using <code>time = 60</code> as guard means that in most cases the event will not get enabled, as the simulator will not check at exactly the right moment.
                    </p>
                    <p>
                        We can visualize the state space of the stopwatch as follows:
                    </p>
                    <img src="images/stopwatch-statespace.png">
                    <p>
                        Initially, the automaton is in its <code>Zero</code> location, and no time has passed, so the model starts in the <code>(Zero, 0.0)</code> state.
                        Then 60 seconds pass (or a little bit more), by means of a <em>time transition</em>.
                        The model is then in the <code>(Zero, 60.0)</code> state.
                        There are in fact infinitely many states between the <code>(Zero, 0.0)</code> and <code>(Zero, 60.0)</code> state, such as <code>(Zero, 0.0000000000001)</code>, <code>(Zero, 0.00000034)</code> and <code>(Zero, 0.71)</code>.
                        And between them are infinitely many time transitions.
                        We can however combine consecutive time transitions to form longer time transitions.
                        And since we can't depict infinitely many states and transitions, we represent them by an arrow labeled with the time that passes between the states, namely <code>60.0</code> seconds, representing the full combined time transition between the states.
                        The <code>time_passed</code> event then becomes enabled in state <code>(Zero, 60.0)</code>, and by an <em>event transition</em> for this event we get to the <code>(One, 60.0)</code> state.
                        Time then passes again, taking the model to the <code>(One, 120.0)</code> state, and so on.
                        Once the model reaches the <code>(Three, 180.0)</code> state, time can progress infinitely, as indicated by the infinity symbol (<code>∞</code>).
                        The state space of a hybrid model thus has two types of transitions: <em>event transitions</em> and <em>time transitions</em>.
                    </p>

                    <h2>Event urgency</h2>
                    <p>
                        In CIF, events are <em>urgent</em>.
                        This means that if an event is enabled, it takes priority over passage of time.
                        As long as at least one event is enabled, time will not progress.
                        This also means that in the example above, event <code>time_passed</code> will not happen after 63 seconds, but really as soon as possible after a minute has passed.
                        We will look at the concept of urgency in more detail later in this module.
                    </p>

                    <h2>Quiz</h2>
                    <div class="quiz">
                        [
                            {
                                type: 'multiple-choice',
                                question: "Which of the following statements about variable <code>time</code> are true?",
                                answers: [
                                    "Variable <code>time</code> measures the time that has passed since the initial state of a model.",
                                    "Variable <code>time</code> can start at any value in the initial state, such as at <code>0.0</code>.",
                                    "Variable <code>time</code> can be used in guards of edges.",
                                    "Variable <code>time</code> needs to be declared, since time isn't measured by default.",
                                    "Variable <code>time</code> can be assigned on edges.",
                                ],
                                correctAnswer: '1, 3'
                            }
                        ];
                    </div>

                    <div class="course-navigation-footer">
                        <div class="course-navigation-prev"><a href="timed-and-hybrid-models.html">Go back to Module 5.1</a></div>
                        <div class="course-navigation-separator">|</div>
                        <div class="course-navigation-next"><a href="continuous-variables.html">Proceed to Module 5.3</a></div>
                    </div>

                </div>
            </div>
        </div>

        <!-- Footer -->
        <div class="container" id="footer">
            <footer class="pt-3 mt-4">
                <ul class="nav justify-content-center border-top pb-1 mb-1">
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org">Eclipse Home</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/privacy.php">Eclipse Privacy Policy</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/termsofuse.php">Eclipse Terms of Use</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/copyright.php">Eclipse Copyright Agent</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal">Eclipse Legal</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.dev/escet/legal.html">Eclipse ESCET Legal</a></li>
                </ul>
                <p class="text-center text-muted">Copyright © 2010, 2025 Contributors to the Eclipse Foundation</p>
            </footer>
        </div>

    </body>
</html>
